open Ev

let main () =
  (*  let l = loop_new [] in*)
  let l = default_loop [] in
    assert (l == default_loop [`FORKCHECK]);
    Printf.printf "Recommended backends: %s\n%!" (String.concat " " (List.map string_of_loop_arg (recommended_backends ())));
    Printf.printf "Embeddable backends: %s\n%!" (String.concat " " (List.map string_of_loop_arg (embeddable_backends ())));
    Printf.printf "Supported backends: %s\n%!" (String.concat " " (List.map string_of_loop_arg (supported_backends ())));
    let count = ref 0 in
    let rec tick = 
      lazy (timer_init 0.0 0.01
	      (fun io evs ->
		 let loop = get_loop io in
		   incr count;

		   if !count = 3 then
		     start l (timer_init 2.0 0.0 (fun io _ -> Printf.printf "HEP\n%!"; stop io));

		   ignore (clear_pending io);

 		   stop io; 
 		   set_priority io !count;
 		   start loop io;
		   Printf.printf "is pending? %b is active? %b priority? %d\n"
		     (is_pending io)
		     (is_active io)
		     (get_priority io)
		   ;
		   Printf.printf "Events: %s\n" (String.concat " " (List.map string_of_revent evs));
		   Printf.printf "Plop!\n%!";
		   if !count = 10 then 
		     begin
		       stop (Lazy.force output_io);
		       stop (Lazy.force tick);
		     end;
		   failwith "uh";
	      )
	   )
    and output_io = 
      lazy (
	io_init Unix.stdout [Ev.WRITE]
	  (fun io evs -> 
	     let _loop = get_loop io in
	       (*Printf.printf "Heip! %s\n%!" "";*)
	       ()
	  )
      )
    in
      start l (Lazy.force output_io);
      start l (Lazy.force tick);
      stop (Lazy.force tick);
      start l (Lazy.force tick);

      timer_again (Lazy.force tick);

      let ctrlc = (signal_init Sys.sigint (fun io _ -> Printf.printf "CTRL-C\n%!"; stop io)) in
	start l ctrlc;
	set_keepalive ctrlc false;
	set_keepalive ctrlc true;
	set_keepalive ctrlc false;

	start l (
	  let counter = ref 0 in
	    idle_init (fun io _ -> 
			 incr counter;
			 if !counter = 10 then
			   (
			     stop io;
			     (*stop ctrlc;*)
			   );
			 Printf.printf "idle\n%!";
		      )
	);

	start l (
	  let rec counter n io _ = 
	    Printf.printf "n = %d\n%!" n;
	    if n > 4 then
	      stop io;
	    set_cb io (counter (n + 1))
	  in
	    timer_init 0.0 0.3 (counter 0)
	);

	let per = 
	  let counter = ref 0 in
	    periodic_init
	      
	      (* (Absolute 10.0) *)
	      (*(Manual (
		fun io now ->
		now +. 0.8
		)
		)*)
	      (Repeating (0.0, 10.0))
	      (fun io _ ->
		 incr counter;
		 if !counter = 5 then
		   stop io;
		 Printf.printf "PLAPPLAPPLAPPLAPPLAPPLAPPLAP, %f->%f\n%!"
		   (loop_now l)
		   (periodic_get_at io)
	      )
	in

	  periodic_set per
	    (Repeating (0.0, 1.0));
	  
	  start l per;

(*
	start l (
	  prepare_init 
	    (fun io _ ->
	       Printf.printf "-------------------- PREPARING --------------------\n%!"
	    )
	);*)

	start l (
	  let counter = ref 0 in
	    child_init
	      0 false
	      (fun io _ ->
		 incr counter;
		 if !counter = 2 then
		   stop io;
		 Printf.printf "--------------------Child %d did something %d, status %d--------------------\n%!" 
		   (child_get_rpid io)
		   (child_get_rstatus io)
		   !counter
	      )
	);
	if (Unix.fork () = 0) then
	  (
	    Unix.sleep 2;
	    exit 1;
	  );
	if (Unix.fork () = 0) then
	  (
	    Unix.sleep 3;
	    exit 1;
	  );

	invoke (Lazy.force tick) [];

	Ev.loop l [];
	()

let () = 
  if not (!Sys.interactive) then
    main ()
