let loop = Ev.loop_new []

let timer ch i = Ev.timer_init 
  0.0 i (
    fun io _ ->
      Printf.printf "%c%!" ch;
  )

let timer_a = timer 'A' 0.01
let timer_b = timer 'T' 0.03
let timer_c = timer 'G' 0.05

let periodic = Ev.periodic_init 
  (Ev.Repeating (0.0, 0.2))
  (
    fun io _ ->
      Printf.printf "\n%!";
  )

let main () = 
  Ev.start loop timer_a;
  Ev.start loop timer_b;
  Ev.start loop timer_c;
  Ev.start loop periodic;
  Ev.loop loop []

let () = main ()

